import EventEmitter from 'little-emitter';
import Item, { ItemData, IsDisabled as IsItemDisabled } from './item';
declare type GetHeaders = (accordion: HTMLElement) => Iterable<HTMLElement>;
declare type GetButton = (params: {
    accordion: HTMLElement;
    header: HTMLElement;
}) => HTMLElement | null;
declare type GetPanel = (params: {
    accordion: HTMLElement;
    button: HTMLElement;
    header: HTMLElement;
}) => HTMLElement | null;
export declare type Options = {
    button?: string | GetButton;
    disabled?: IsItemDisabled;
    header?: string | GetHeaders;
    panel?: GetPanel;
};
export default class BaseAccordion extends EventEmitter {
    protected _accordion: HTMLElement;
    protected _items: Array<Item>;
    protected static _getState(): any;
    static mount(el: HTMLElement, options?: Options): BaseAccordion;
    ['constructor']: typeof BaseAccordion;
    constructor(accordion: HTMLElement, _options?: Options);
    [Symbol.iterator](): Iterator<ItemData>;
    readonly accordion: HTMLElement;
    close(index: number): this;
    get(index: number): ItemData;
    has(index: number): boolean;
    readonly length: number;
    open(index: number): this;
    protected _get(index: number): Item;
    protected _onItem(item: Item, _state: any): void;
    private _collectItems;
}
export {};
