import EventEmitter from 'little-emitter';
export declare type ItemData = {
    accordion: HTMLElement;
    button: HTMLElement;
    header: HTMLElement;
    index: number;
    isOpen: boolean;
    panel: HTMLElement;
};
export declare type IsDisabled = (data: ItemData, next: () => boolean) => boolean;
declare type ActionOptions = {
    force: boolean;
};
declare type Options = {
    accordion: HTMLElement;
    button: HTMLElement;
    header: HTMLElement;
    index: number;
    panel: HTMLElement;
    isDisabled?: IsDisabled;
};
export default class Item extends EventEmitter {
    accordion: Options['accordion'];
    button: Options['button'];
    header: Options['header'];
    index: Options['index'];
    panel: Options['panel'];
    isOpen: boolean;
    private isDisabled;
    constructor(options: Options);
    readonly data: ItemData;
    close(options?: ActionOptions): void;
    open(options?: ActionOptions): void;
    toggle(open?: boolean, options?: ActionOptions): void;
}
export {};
